unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, DragDrop, DropTarget, DragDropText,
  StdCtrls, RVStyle, RVScroll, RichView, RVEdit;

type
  TfrmMain = class(TForm)
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    ListBox1: TListBox;
    DropTextTarget1: TDropTextTarget;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure DropTextTarget1Drop(Sender: TObject; ShiftState: TShiftState;
      APoint: TPoint; var Effect: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  DropTextTarget1.Register(ListBox1);

  RichViewEdit1.Clear;
  RichViewEdit1.AddNL('Sample item', 0, 0);
  RichViewEdit1.Format;
  RichViewEdit1.SelectAll;
end;

procedure TfrmMain.DropTextTarget1Drop(Sender: TObject; ShiftState: TShiftState;
  APoint: TPoint; var Effect: Integer);
var p: Integer;
    s: String;
begin
  s := AdjustLineBreaks(DropTextTarget1.Text);
  p := Pos(#13, s);
  if p>0 then
    s := Copy(s, 1, p-1); // for multiline text, inserting the first line
  if s<>'' then
    ListBox1.Items.Add(s);
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  DropTextTarget1.Unregister;
end;

end.
